/*
 * RCS info: $Source: /export/work/usr/CVS_DB/FP-Fixer/src/lib/fpfix64/average.h,v $
 *           $Revision: 1.1.1.1 $
 *           $Date: 2008/11/27 07:24:47 $
 *           $Author: ono $
 *           $Log: average.h,v $
 *           Revision 1.1.1.1  2008/11/27 07:24:47  ono
 *           first cvs modules.
 *
 * Copyright (c) 2008 ISHIZUE Design Automation Corp.
 */

/****************************************************************************************/
//FILE : average.h(Average calculation)
//Name : K.Tsuchiya
//Copyright (C) 2004 - 2008 by ISHIZUE Design Automation Corp. All Right Reserved.
//Date :2006/5/1
// ...Average calculation
//exsample.)
//    ave=aveIni();
//    aveInst(ave,10.0);
//    aveInst(ave,900.0);
//    aveBackOpe(ave);
//    printf("%f",ave->head->val);
//    aveDes(ave);
/****************************************************************************************/
#ifndef __AVERAGE_HEADER
#define __AVERAGE_HEADER
//struct average
typedef struct _AVENODE
{
  int    level;
  double val;
  struct _AVENODE* son;
}
  AVENODE;

typedef struct _AVERAGE
{
  int size;
  AVENODE* head;
  AVENODE* tail;
  AVENODE* trash; //son->son->son->son->...
}
  AVERAGE;

extern AVERAGE* aveIni(void); //Initializing.
extern AVERAGE* aveDes(AVERAGE*ave);//Destruct.
extern double aveInst(AVERAGE*ave, double val);//Insert value
extern double aveBackOpe(AVERAGE* ave);//Backend operation(to get average value).
#endif
