/*
 * RCS info: $Source: /export/work/usr/CVS_DB/FP-Fixer/src/cmd/pfl2dsp2_2_08/dsp_rnd.h,v $
 *           $Revision: 1.3 $
 *           $Date: 2010/01/14 09:57:31 $
 *           $Author: haru $
 *           $Log: dsp_rnd.h,v $
 *           Revision 1.3  2010/01/14 09:57:31  haru
 *           *** empty log message ***
 *
 *           Revision 1.2  2009/11/26 02:36:47  haru
 *           *** empty log message ***
 *
 *           Revision 1.5  2009/11/22 05:57:47  haru
 *           *** empty log message ***
 *
 *           Revision 1.4  2009/09/14 00:27:25  haru
 *
 *           (1)dsp_mul.h -> LONGLONG define delete
 *           (2)minus(-x) -> add bit mask
 *
 *           Revision 1.3  2009/09/07 01:08:32  haru
 *
 *           Chk. rnd_mode e and r
 *
 *           Revision 1.2  2009/04/13 05:18:20  haru
 *
 *           Chg. marume
 *             tran, rnd, even, foor, ceiling
 *
 *           Revision 1.1  2009/04/06 01:33:57  haru
 *
 *           First commit
 *
 *
 * Copyright (c) 2009 ISHIZUE Design Automation Corp.
 */

/*============================================================================
 * 쐬F
 * 쐬ҁF
 * t@CFdsp_rnd.h
 * Tv  FŒ菬_ۂߏ֐
 *==========================================================================*/

#ifndef __FPF_RND
#define __FPF_RND

#define __FPF_RND_USED_LONGLONG
#define __FPF_RND_USED_DOUBLE_RND

#ifdef __FPF_MAX_16BIT
#define _FPF_RND_INT_MASK       0xffffU
#define _FPF_RND_INT_SINBIT     0x8000
#else
#define _FPF_RND_INT_MASK       0xffffffffU
#define _FPF_RND_INT_SINBIT     0x80000000
#endif

#ifdef __FPF_RND_USED_LONGLONG
#ifdef __FPF_MAX_16BIT
#define _FPF_RND_LONG_TYPE      long
#define _FPF_RND_ULONG_TYPE     unsigned long
#define _FPF_RND_LONG_MASK      0xffffffffLU
#define _FPF_RND_LONG_0x01      0x01LU
#define _FPF_RND_LONG_SINBIT    0x80000000L
#else
#define _FPF_RND_LONG_TYPE      long long
#define _FPF_RND_ULONG_TYPE     unsigned long long
#define _FPF_RND_LONG_MASK      0xffffffffffffffffLLU
#define _FPF_RND_LONG_0x01      0x01LLU
#define _FPF_RND_LONG_SINBIT    0x8000000000000000LL
#endif
#endif


//
// ؎̂ }XN
//

// ؎̂  32Bit
#ifdef _NO_INLINE_FPF_RND
static int _fixedIntMaskTrn( int fi, int pos )
#else
static inline int _fixedIntMaskTrn( int fi, int pos )
#endif
{
    unsigned int mask;
    unsigned int mask2;

    mask =_FPF_RND_INT_MASK << pos;
    if( fi < 0 ){
        mask2 = ~mask;
        fi = (fi & mask2) ? (fi & mask) + (0x1U << pos) : fi & mask;
        return fi;
    } else {
        return fi & mask;
    }
}

#ifdef __FPF_RND_USED_LONGLONG
// ؎̂ L 64Bit
#ifdef _NO_INLINE_FPF_RND
static _FPF_RND_LONG_TYPE _fixedInt64MaskTrn( _FPF_RND_LONG_TYPE fi, int pos )
#else
static inline _FPF_RND_LONG_TYPE _fixedInt64MaskTrn( _FPF_RND_LONG_TYPE fi, int pos )
#endif
{
    unsigned _FPF_RND_LONG_TYPE mask;
    unsigned _FPF_RND_LONG_TYPE mask2;

    mask =_FPF_RND_LONG_MASK << pos;
    if( fi < 0 ){
        mask2 = ~mask;
        fi = (fi & mask2) ? (fi & mask) + (_FPF_RND_LONG_0x01 << pos) : fi & mask;
        return fi;
    } else {
        return fi & mask;
    }
}
#endif

// ؎̂  32Bit
#ifdef _NO_INLINE_FPF_RND
static unsigned int _fixedUIntMaskTrn( unsigned int fi, int pos )
#else
static inline unsigned int _fixedUIntMaskTrn( unsigned int fi, int pos )
#endif
{
    unsigned int mask;

    mask = _FPF_RND_INT_MASK << pos;
    return fi & mask;
}

#ifdef __FPF_RND_USED_LONGLONG
// ؎̂  64Bit
#ifdef _NO_INLINE_FPF_RND
static unsigned _FPF_RND_LONG_TYPE _fixedUInt64MaskTrn( unsigned _FPF_RND_LONG_TYPE fi, int pos )
#else
static inline unsigned _FPF_RND_LONG_TYPE _fixedUInt64MaskTrn( unsigned _FPF_RND_LONG_TYPE fi, int pos )
#endif
{
    unsigned _FPF_RND_LONG_TYPE mask;

    mask = _FPF_RND_LONG_MASK << pos;
    return fi & mask;
}
#endif

//
// ÔP }XN
//

// ÔP  32Bit
#ifdef _NO_INLINE_FPF_RND
static int _fixedIntMaskRnd( int fi, int ps )
#else
static inline int _fixedIntMaskRnd( int fi, int ps )
#endif
{
    unsigned int iMask;
    unsigned int iChkBit;

    iMask = _FPF_RND_INT_MASK << ps;
    iChkBit = 0x01U << (ps - 1) ;
    if( fi < 0 ){
        fi = ~fi + 1;
        fi = (fi & iChkBit ) ? (fi & iMask) + (iChkBit << 1) : fi & iMask;
        fi = ~fi + 1;
    } else {
        fi = (fi & iChkBit) ? (fi & iMask) + (iChkBit << 1) : fi & iMask;
    }
    return fi;
}

#ifdef __FPF_RND_USED_LONGLONG
// ÔP  64Bit
#ifdef _NO_INLINE_FPF_RND
static _FPF_RND_LONG_TYPE _fixedInt64MaskRnd( _FPF_RND_LONG_TYPE fi, int ps )
#else
static inline _FPF_RND_LONG_TYPE _fixedInt64MaskRnd( _FPF_RND_LONG_TYPE fi, int ps )
#endif
{
    unsigned _FPF_RND_LONG_TYPE iMask;
    unsigned _FPF_RND_LONG_TYPE iChkBit;

    iMask = _FPF_RND_LONG_MASK << ps;
    iChkBit = _FPF_RND_LONG_0x01 << (ps - 1) ;
    if( fi < 0 ){
        fi = ~fi + 1;
        fi = (fi & iChkBit ) ? (fi & iMask) + (iChkBit << 1) : fi & iMask;
        fi = ~fi + 1;
    } else {
        fi = (fi & iChkBit) ? (fi & iMask) + (iChkBit << 1) : fi & iMask;
    }
    return fi;
}
#endif

// ÔP  32Bit
#ifdef _NO_INLINE_FPF_RND
static unsigned int _fixedUIntMaskRnd( unsigned int fi, int ps )
#else
static inline unsigned int _fixedUIntMaskRnd( unsigned int fi, int ps )
#endif
{
    unsigned int iMask;
    unsigned int iChkBit;

    iMask = _FPF_RND_INT_MASK << ps;
    iChkBit = 0x01U << (ps - 1) ;
    fi = (fi & iChkBit) ? (fi & iMask) + (iChkBit << 1) : fi & iMask;
    return fi;
}

#ifdef __FPF_RND_USED_LONGLONG
// ÔP  64Bit
#ifdef _NO_INLINE_FPF_RND
static unsigned _FPF_RND_LONG_TYPE _fixedUInt64MaskRnd( unsigned _FPF_RND_LONG_TYPE fi, int ps )
#else
static inline unsigned _FPF_RND_LONG_TYPE _fixedUInt64MaskRnd( unsigned _FPF_RND_LONG_TYPE fi, int ps )
#endif
{
    unsigned _FPF_RND_LONG_TYPE iMask;
    unsigned _FPF_RND_LONG_TYPE iChkBit;

    iMask = _FPF_RND_LONG_MASK << ps;
    iChkBit = _FPF_RND_LONG_0x01 << (ps - 1) ;

    fi = (fi & iChkBit) ? (fi & iMask) + (iChkBit << 1) : fi & iMask;
    return fi;
}
#endif

//
// ۂ }XN
//

// ۂ L 32Bit
#ifdef _NO_INLINE_FPF_RND
static int _fixedIntMaskRndEven( int fi, int ps )
#else
static inline int _fixedIntMaskRndEven( int fi, int ps )
#endif
{
    unsigned int iMask;
    unsigned int iChkBit;
    unsigned int iChkBit2;
    unsigned int iBase;

    iMask = _FPF_RND_INT_MASK << ps;
    iChkBit = 0x01U << (ps - 1) ;
    iChkBit2 = 0x01U << ps ;
    iBase = fi;

    if( fi < 0 ){
        fi = ~fi + 1;
        iBase = fi;
        if( fi & iChkBit ){
            fi = (fi & iMask) + iChkBit2;
            if( (iBase & (~iMask)) == iChkBit && !(iBase & iChkBit2) ){
                fi = fi - iChkBit2;
            }
        } else {
            fi = fi & iMask;
        }
        fi = ~fi + 1;
    } else {
        if( fi & iChkBit ){
            fi = (fi & iMask) + iChkBit2;
            if( (iBase & (~iMask)) == iChkBit && !(iBase & iChkBit2) ){
                fi = fi - iChkBit2;
            }
        } else {
            fi = fi & iMask;
        }
    }
    return fi;
}

#ifdef __FPF_RND_USED_LONGLONG
// ۂ L 64Bit
#ifdef _NO_INLINE_FPF_RND
static _FPF_RND_LONG_TYPE _fixedInt64MaskRndEven( _FPF_RND_LONG_TYPE fi, int ps )
#else
static inline _FPF_RND_LONG_TYPE _fixedInt64MaskRndEven( _FPF_RND_LONG_TYPE fi, int ps )
#endif
{
    unsigned _FPF_RND_LONG_TYPE iMask;
    unsigned _FPF_RND_LONG_TYPE iChkBit;
    unsigned _FPF_RND_LONG_TYPE iChkBit2;
    unsigned _FPF_RND_LONG_TYPE iBase;

    iMask = _FPF_RND_LONG_MASK << ps;
    iChkBit = _FPF_RND_LONG_0x01 << (ps - 1) ;
    iChkBit2 = _FPF_RND_LONG_0x01 << ps ;
    iBase = fi;

    if( fi < 0 ){
        fi = ~fi + 1;
        iBase = fi;
        if( fi & iChkBit ){
            fi = (fi & iMask) + iChkBit2;
            if( (iBase & (~iMask)) == iChkBit && !(iBase & iChkBit2) ){
                fi = fi - iChkBit2;
            }
        } else {
            fi = fi & iMask;
        }
        fi = ~fi + 1;
    } else {
        if( fi & iChkBit ){
            fi = (fi & iMask) + iChkBit2;
            if( (iBase & (~iMask)) == iChkBit && !(iBase & iChkBit2) ){
                fi = fi - iChkBit2;
            }
        } else {
            fi = fi & iMask;
        }
    }
    return fi;
}
#endif

// ۂ  32Bit
#ifdef _NO_INLINE_FPF_RND
static unsigned int _fixedUIntMaskRndEven( unsigned int fi, int ps )
#else
static inline unsigned int _fixedUIntMaskRndEven( unsigned int fi, int ps )
#endif
{
    unsigned int iMask;
    unsigned int iChkBit;
    unsigned int iChkBit2;
    unsigned int iBase;

    iMask = _FPF_RND_INT_MASK << ps;
    iChkBit = 0x01U << (ps - 1) ;
    iChkBit2 = 0x01U << ps ;
    iBase = fi;

    if( fi & iChkBit ){
        fi = (fi & iMask) + iChkBit2;
        if( (iBase & (~iMask)) == iChkBit && !(iBase & iChkBit2) ){
            fi = fi - iChkBit2;
        }
    } else {
        fi = fi & iMask;
    }
    return fi;
}

#ifdef __FPF_RND_USED_LONGLONG
// ۂ  64Bit
#ifdef _NO_INLINE_FPF_RND
static unsigned _FPF_RND_LONG_TYPE _fixedUInt64MaskRndEven( unsigned _FPF_RND_LONG_TYPE fi, int ps )
#else
static inline unsigned _FPF_RND_LONG_TYPE _fixedUInt64MaskRndEven( unsigned _FPF_RND_LONG_TYPE fi, int ps )
#endif
{
    unsigned _FPF_RND_LONG_TYPE iMask;
    unsigned _FPF_RND_LONG_TYPE iChkBit;
    unsigned _FPF_RND_LONG_TYPE iChkBit2;
    unsigned _FPF_RND_LONG_TYPE iBase;

    iMask = _FPF_RND_LONG_MASK << ps;
    iChkBit = _FPF_RND_LONG_0x01 << (ps - 1) ;
    iChkBit2 = _FPF_RND_LONG_0x01 << ps ;
    iBase = fi;

    if( fi & iChkBit ){
        fi = (fi & iMask) + iChkBit2;
        if( (iBase & (~iMask)) == iChkBit && !(iBase & iChkBit2) ){
            fi = fi - iChkBit2;
        }
    } else {
        fi = fi & iMask;
    }
    return fi;
}
#endif

//
// ceiling }XN
//

// ceiling  32Bit
#ifdef _NO_INLINE_FPF_RND
static int _fixedIntMaskCeiling( int fi, int pos )
#else
static inline int _fixedIntMaskCeiling( int fi, int pos )
#endif
{
    unsigned int mask;
    unsigned int mask2;

    mask = _FPF_RND_INT_MASK << pos;
    mask2 = ~mask;
    fi = (fi & mask2) ? (fi & mask) + (0x1U << pos) : fi & mask;
    return fi;
}

#ifdef __FPF_RND_USED_LONGLONG
// ceiling  64Bit
#ifdef _NO_INLINE_FPF_RND
static _FPF_RND_LONG_TYPE _fixedInt64MaskCeiling( _FPF_RND_LONG_TYPE fi, int pos )
#else
static inline _FPF_RND_LONG_TYPE _fixedInt64MaskCeiling( _FPF_RND_LONG_TYPE fi, int pos )
#endif
{
    unsigned _FPF_RND_LONG_TYPE mask;
    unsigned _FPF_RND_LONG_TYPE mask2;

    mask = _FPF_RND_LONG_MASK << pos;
    mask2 = ~mask;
    fi = (fi & mask2) ? (fi & mask) + (0x1U << pos) : fi & mask;
    return fi;
}
#endif

// ceiling  32Bit
#ifdef _NO_INLINE_FPF_RND
static unsigned int _fixedUIntMaskCeiling( unsigned int fi, int pos )
#else
static inline unsigned int _fixedUIntMaskCeiling( unsigned int fi, int pos )
#endif
{
    unsigned int mask;
    unsigned int mask2;

    mask = _FPF_RND_INT_MASK << pos;
    mask2 = ~mask;
    fi = (fi & mask2) ? (fi & mask) + (0x1U << pos) : fi & mask;
    return fi;
}

#ifdef __FPF_RND_USED_LONGLONG
// ceiling  64Bit
#ifdef _NO_INLINE_FPF_RND
static unsigned _FPF_RND_LONG_TYPE _fixedUInt64MaskCeiling( unsigned _FPF_RND_LONG_TYPE fi, int pos )
#else
static inline unsigned _FPF_RND_LONG_TYPE _fixedUInt64MaskCeiling( unsigned _FPF_RND_LONG_TYPE fi, int pos )
#endif
{
    unsigned _FPF_RND_LONG_TYPE mask;
    unsigned _FPF_RND_LONG_TYPE mask2;

    mask = _FPF_RND_LONG_MASK << pos;
    mask2 = ~mask;
    fi = (fi & mask2) ? (fi & mask) + (0x1U << pos) : fi & mask;
    return fi;
}
#endif

//
// floor }XN
//

// floor  32Bit
#ifdef _NO_INLINE_FPF_RND
static int _fixedIntMaskFloor( int fi, int pos )
#else
static inline int _fixedIntMaskFloor( int fi, int pos )
#endif
{
    unsigned int mask;

    mask = _FPF_RND_INT_MASK << pos;
    fi = fi & mask;
    return fi;
}

#ifdef __FPF_RND_USED_LONGLONG
// floor  64Bit
#ifdef _NO_INLINE_FPF_RND
static _FPF_RND_LONG_TYPE _fixedInt64MaskFloor( _FPF_RND_LONG_TYPE fi, int pos )
#else
static inline _FPF_RND_LONG_TYPE _fixedInt64MaskFloor( _FPF_RND_LONG_TYPE fi, int pos )
#endif
{
    unsigned _FPF_RND_LONG_TYPE mask;

    mask = _FPF_RND_LONG_MASK << pos;
    fi = fi & mask;
    return fi;
}
#endif

// floor  32Bit
#ifdef _NO_INLINE_FPF_RND
static unsigned int _fixedUIntMaskFloor( unsigned int fi, int pos )
#else
static inline unsigned int _fixedUIntMaskFloor( unsigned int fi, int pos )
#endif
{
    unsigned int mask;

    mask = _FPF_RND_INT_MASK << pos;
    fi = fi & mask;
    return fi;
}

#ifdef __FPF_RND_USED_LONGLONG
// floor  64Bit
#ifdef _NO_INLINE_FPF_RND
static unsigned _FPF_RND_LONG_TYPE _fixedUInt64MaskFloor( unsigned _FPF_RND_LONG_TYPE fi, int pos )
#else
static inline unsigned _FPF_RND_LONG_TYPE _fixedUInt64MaskFloor( unsigned _FPF_RND_LONG_TYPE fi, int pos )
#endif
{
    unsigned _FPF_RND_LONG_TYPE mask;

    mask = _FPF_RND_LONG_MASK << pos;
    fi = fi & mask;
    return fi;
}
#endif

//
// EVtg
//

// EVtg؎̂ L  32Bit
#ifdef _NO_INLINE_FPF_RND
static int _fixedIntLsftTrn( int fi, int pos )
#else
static inline int _fixedIntLsftTrn( int fi, int pos )
#endif
{
    unsigned int mask;
    unsigned int mask2;

    mask = _FPF_RND_INT_MASK << pos;
    if( fi < 0 ){
        mask2 = ~mask;
        fi = (fi & mask2) ? (fi >> pos) + 1 : fi >> pos;
        return fi;
    } else {
        return fi >> pos;
    }
}

#ifdef __FPF_RND_USED_LONGLONG
// EVtg؎̂ L 64Bit
#ifdef _NO_INLINE_FPF_RND
static _FPF_RND_LONG_TYPE _fixedInt64LsftTrn( _FPF_RND_LONG_TYPE fi, int pos )
#else
static inline _FPF_RND_LONG_TYPE _fixedInt64LsftTrn( _FPF_RND_LONG_TYPE fi, int pos )
#endif
{
    unsigned _FPF_RND_LONG_TYPE mask;
    unsigned _FPF_RND_LONG_TYPE mask2;

    if( fi < 0 ){
        mask = _FPF_RND_LONG_MASK << pos;
        mask2 = ~mask;
        fi = (fi & mask2) ? (fi >> pos) + 1 : fi >> pos;
        return fi;
    } else {
        return fi >> pos;
    }
}
#endif

// EVtg؎̂  32Bit
#ifdef _NO_INLINE_FPF_RND
static unsigned int _fixedUIntLsftTrn( unsigned int fi, int pos )
#else
static inline unsigned int _fixedUIntLsftTrn( unsigned int fi, int pos )
#endif
{
    return fi >> pos;
}

#ifdef __FPF_RND_USED_LONGLONG
// EVtg؎̂  64Bit
#ifdef _NO_INLINE_FPF_RND
static unsigned _FPF_RND_LONG_TYPE _fixedUInt64LsftTrn( unsigned _FPF_RND_LONG_TYPE fi, int pos )
#else
static inline unsigned _FPF_RND_LONG_TYPE _fixedUInt64LsftTrn( unsigned _FPF_RND_LONG_TYPE fi, int pos )
#endif
{
    return fi >> pos;
}
#endif

//
// ÔP EVtg
//

// EVtgÔP  32Bit
#ifdef _NO_INLINE_FPF_RND
static int _fixedIntLsftRnd( int fi, int ps )
#else
static inline int _fixedIntLsftRnd( int fi, int ps )
#endif
{
    unsigned int iChkBit;

    iChkBit = 0x01U << (ps - 1) ;
    if( fi < 0 ){
        if( _FPF_RND_INT_SINBIT != fi ){
            fi = ~fi + 1;
            fi = (fi & iChkBit ) ? (fi >> ps) + 1 : fi >> ps;
            fi = ~fi + 1;
        } else {
            fi = fi >> ps;
        }
    } else {
        fi = (fi & iChkBit) ? (fi >> ps) + 1 : fi >> ps;
    }
    return fi;
}

#ifdef __FPF_RND_USED_LONGLONG
// EVtgÔP  64Bit
#ifdef _NO_INLINE_FPF_RND
static _FPF_RND_LONG_TYPE _fixedInt64LsftRnd( _FPF_RND_LONG_TYPE fi, int ps )
#else
static inline _FPF_RND_LONG_TYPE _fixedInt64LsftRnd( _FPF_RND_LONG_TYPE fi, int ps )
#endif
{
    unsigned _FPF_RND_LONG_TYPE iChkBit;

    iChkBit = _FPF_RND_LONG_0x01 << (ps - 1) ;
    if( fi < 0 ){
        if( _FPF_RND_LONG_SINBIT != fi ){
            fi = ~fi + 1;
            fi = (fi & iChkBit ) ? (fi >> ps) + 1 : fi >> ps;
            fi = ~fi + 1;
        } else {
            fi = fi >> ps;
        }
    } else {
        fi = (fi & iChkBit) ? (fi >> ps) + 1 : fi >> ps;
    }
    return fi;
}
#endif

// EVtgÔP  32Bit
#ifdef _NO_INLINE_FPF_RND
static unsigned int _fixedUIntLsftRnd( unsigned int fi, int ps )
#else
static inline unsigned int _fixedUIntLsftRnd( unsigned int fi, int ps )
#endif
{
    unsigned int iChkBit;

    iChkBit = 0x01U << (ps - 1) ;
    fi = (fi & iChkBit) ? (fi >> ps) + 1 : fi >> ps;
    return fi;
}

#ifdef __FPF_RND_USED_LONGLONG
// EVtgÔP  64Bit
#ifdef _NO_INLINE_FPF_RND
static unsigned _FPF_RND_LONG_TYPE _fixedUInt64LsftRnd( unsigned _FPF_RND_LONG_TYPE fi, int ps )
#else
static inline unsigned _FPF_RND_LONG_TYPE _fixedUInt64LsftRnd( unsigned _FPF_RND_LONG_TYPE fi, int ps )
#endif
{
    unsigned _FPF_RND_LONG_TYPE iChkBit;

    iChkBit = _FPF_RND_LONG_0x01 << (ps - 1) ;
    fi = (fi & iChkBit) ? (fi >> ps) + 1 : fi >> ps;
    return fi;
}
#endif

//
// ۂ EVtg
//
// EVtgۂ L 32Bit
#ifdef _NO_INLINE_FPF_RND
static int _fixedIntLsftRndEven( int fi, int ps )
#else
static inline int _fixedIntLsftRndEven( int fi, int ps )
#endif
{
    unsigned int iMask;
    unsigned int iChkBit;
    unsigned int iChkBit2;
    int iBase;

    iMask = _FPF_RND_INT_MASK << ps;
    iChkBit = 0x01U << (ps - 1) ;
    iChkBit2 = 0x01U << ps ;
    iBase = fi;
    if( fi < 0 && _FPF_RND_INT_SINBIT != fi ){
        fi = ~fi + 1;
        iBase = fi;
        if( fi & iChkBit ){
            fi = (fi >> ps) + 1;
            if( (iBase & (~iMask)) == iChkBit && !(iBase & iChkBit2) ){
                fi = fi - 1;
            }
        } else {
            fi = fi >> ps;
        }
        fi = ~fi + 1;
    } else {
        if( fi & iChkBit ){
            fi = (fi >> ps) + 1;
            if( (iBase & (~iMask)) == iChkBit && !(iBase & iChkBit2) ){
                fi = fi - 1;
            }
        } else {
            fi = fi >> ps;
        }
    }
    return fi;
}

#ifdef __FPF_RND_USED_LONGLONG
// EVtgۂ L 64Bit
#ifdef _NO_INLINE_FPF_RND
static _FPF_RND_LONG_TYPE _fixedInt64LsftRndEven( _FPF_RND_LONG_TYPE fi, int ps )
#else
static inline _FPF_RND_LONG_TYPE _fixedInt64LsftRndEven( _FPF_RND_LONG_TYPE fi, int ps )
#endif
{
    unsigned _FPF_RND_LONG_TYPE iMask;
    unsigned _FPF_RND_LONG_TYPE iChkBit;
    unsigned _FPF_RND_LONG_TYPE iChkBit2;
    _FPF_RND_LONG_TYPE iBase;

    iMask = _FPF_RND_LONG_MASK << ps;
    iChkBit = _FPF_RND_LONG_0x01 << (ps - 1) ;
    iChkBit2 = _FPF_RND_LONG_0x01 << ps ;
    iBase = fi;
    if( fi < 0 && _FPF_RND_LONG_SINBIT != fi ){
        fi = ~fi + 1;
        iBase = fi;
        if( fi & iChkBit ){
            fi = (fi >> ps) + 1;
            if( (iBase & (~iMask)) == iChkBit && !(iBase & iChkBit2) ){
                fi = fi - 1;
            }
        } else {
            fi = fi >> ps;
        }
        fi = ~fi + 1;
    } else {
        if( fi & iChkBit ){
            fi = (fi >> ps) + 1;
            if( (iBase & (~iMask)) == iChkBit && !(iBase & iChkBit2) ){
                fi = fi - 1;
            }
        } else {
            fi = fi >> ps;
        }
    }
    return fi;
}
#endif

// EVtgۂ  32Bit
#ifdef _NO_INLINE_FPF_RND
static unsigned int _fixedUIntLsftRndEven( unsigned int fi, int ps )
#else
static inline unsigned int _fixedUIntLsftRndEven( unsigned int fi, int ps )
#endif
{
    unsigned int iMask;
    unsigned int iChkBit;
    unsigned int iChkBit2;
    unsigned int iBase;

    iMask = _FPF_RND_INT_MASK << ps;
    iChkBit = 0x01U << (ps - 1) ;
    iChkBit2 = 0x01U << ps ;
    iBase = fi;
    if( fi & iChkBit ){
        fi = (fi >> ps) + 1;
        if( (iBase & (~iMask)) == iChkBit && !(iBase & iChkBit2) ){
            fi = fi - 1;
        }
    } else {
        fi = fi >> ps;
    }
    return fi;
}

#ifdef __FPF_RND_USED_LONGLONG
// EVtgۂ  64Bit
#ifdef _NO_INLINE_FPF_RND
static unsigned _FPF_RND_LONG_TYPE _fixedUInt64LsftRndEven( unsigned _FPF_RND_LONG_TYPE fi, int ps )
#else
static inline unsigned _FPF_RND_LONG_TYPE _fixedUInt64LsftRndEven( unsigned _FPF_RND_LONG_TYPE fi, int ps )
#endif
{
    unsigned _FPF_RND_LONG_TYPE iMask;
    unsigned _FPF_RND_LONG_TYPE iChkBit;
    unsigned _FPF_RND_LONG_TYPE iChkBit2;
    unsigned _FPF_RND_LONG_TYPE iBase;

    iMask = _FPF_RND_LONG_MASK << ps;
    iChkBit = _FPF_RND_LONG_0x01 << (ps - 1) ;
    iChkBit2 = _FPF_RND_LONG_0x01 << ps ;
    iBase = fi;
    if( fi & iChkBit ){
        fi = (fi >> ps) + 1;
        if( (iBase & (~iMask)) == iChkBit && !(iBase & iChkBit2) ){
            fi = fi - iChkBit2;
        }
    } else {
        fi = fi >> ps;
    }
    return fi;
}
#endif

//
// ceiling EVtg
//

// EVtgceiling  32Bit
#ifdef _NO_INLINE_FPF_RND
static int _fixedIntLsftCeiling( int fi, int pos )
#else
static inline int _fixedIntLsftCeiling( int fi, int pos )
#endif
{
    unsigned int mask;
    unsigned int mask2;

    mask = _FPF_RND_INT_MASK << pos;
    mask2 = ~mask;
    fi = (fi & mask2) ? (fi >> pos) + 1 : fi >> pos;
    return fi;
}

#ifdef __FPF_RND_USED_LONGLONG
// EVtgceiling  64Bit
#ifdef _NO_INLINE_FPF_RND
static _FPF_RND_LONG_TYPE _fixedInt64LsftCeiling( _FPF_RND_LONG_TYPE fi, int pos )
#else
static inline _FPF_RND_LONG_TYPE _fixedInt64LsftCeiling( _FPF_RND_LONG_TYPE fi, int pos )
#endif
{
    unsigned _FPF_RND_LONG_TYPE mask;
    unsigned _FPF_RND_LONG_TYPE mask2;

    mask = _FPF_RND_LONG_MASK << pos;
    mask2 = ~mask;
    fi = (fi & mask2) ? (fi >> pos) + 1 : fi >> pos;
    return fi;
}
#endif

// EVtgceiling  32Bit
#ifdef _NO_INLINE_FPF_RND
static unsigned int _fixedUIntLsftCeiling( unsigned int fi, int pos )
#else
static inline unsigned int _fixedUIntLsftCeiling( unsigned int fi, int pos )
#endif
{
    unsigned int mask;
    unsigned int mask2;

    mask = _FPF_RND_INT_MASK << pos;
    mask2 = ~mask;
    fi = (fi & mask2) ? (fi >> pos) + 1 : fi >> pos;
    return fi;
}

#ifdef __FPF_RND_USED_LONGLONG
// EVtgceiling  64Bit
#ifdef _NO_INLINE_FPF_RND
static unsigned _FPF_RND_LONG_TYPE _fixedUInt64LsftCeiling( unsigned _FPF_RND_LONG_TYPE fi, int pos )
#else
static inline unsigned _FPF_RND_LONG_TYPE _fixedUInt64LsftCeiling( unsigned _FPF_RND_LONG_TYPE fi, int pos )
#endif
{
    unsigned _FPF_RND_LONG_TYPE mask;
    unsigned _FPF_RND_LONG_TYPE mask2;

    mask = _FPF_RND_LONG_MASK << pos;
    mask2 = ~mask;
    fi = (fi & mask2) ? (fi >> pos) + 1 : fi >> pos;
    return fi;
}
#endif

//
// floor EVtg
//

// EVtgfloor  32Bit
#ifdef _NO_INLINE_FPF_RND
static int _fixedIntLsftFloor( int fi, int pos )
#else
static inline int _fixedIntLsftFloor( int fi, int pos )
#endif
{
    fi = fi >> pos;
    return fi;
}

#ifdef __FPF_RND_USED_LONGLONG
// EVtgfloor  64Bit
#ifdef _NO_INLINE_FPF_RND
static _FPF_RND_LONG_TYPE _fixedInt64LsftFloor( _FPF_RND_LONG_TYPE fi, int pos )
#else
static inline _FPF_RND_LONG_TYPE _fixedInt64LsftFloor( _FPF_RND_LONG_TYPE fi, int pos )
#endif
{
    fi = fi >> pos;
    return fi;
}
#endif

// EVtgfloor  32Bit
#ifdef _NO_INLINE_FPF_RND
static unsigned int _fixedUIntLsftFloor( unsigned int fi, int pos )
#else
static inline unsigned int _fixedUIntLsftFloor( unsigned int fi, int pos )
#endif
{
    fi = fi >> pos;
    return fi;
}

#ifdef __FPF_RND_USED_LONGLONG
// EVtgfloor  64Bit
#ifdef _NO_INLINE_FPF_RND
static unsigned _FPF_RND_LONG_TYPE _fixedUInt64LsftFloor( unsigned _FPF_RND_LONG_TYPE fi, int pos )
#else
static inline unsigned _FPF_RND_LONG_TYPE _fixedUInt64LsftFloor( unsigned _FPF_RND_LONG_TYPE fi, int pos )
#endif
{
    fi = fi >> pos;
    return fi;
}
#endif


#ifdef __FPF_RND_USED_DOUBLE_RND
//
// double To fixed ÔP
//
static int _doubleToInt32Rnd( double fi )
{
    unsigned int t;

    if( fi < 0 ){
        fi = -fi;
        t = fi;
        if( (fi - t) >= 0.5 ){
            fi += 0.5;
        }
        fi = -fi;
    } else {
        t = fi;
        if( (fi - t) >= 0.5 ){
            fi += 0.5;
        }
    }
    return (int)fi;
}

#ifdef __FPF_RND_USED_LONGLONG
static _FPF_RND_LONG_TYPE _doubleToInt64Rnd( double fi )
{
    unsigned _FPF_RND_LONG_TYPE t;

    if( fi < 0 ){
        fi = -fi;
        t = fi;
        if( (fi - t) >= 0.5 ){
            fi += 0.5;
        }
        fi = -fi;
    } else {
        t = fi;
        if( (fi - t) >= 0.5 ){
            fi += 0.5;
        }
    }
    return (_FPF_RND_LONG_TYPE)fi;
}
#endif

//
// double To fixed ۂ
//
static int _doubleToInt32Even( double fi )
{
    unsigned int t;
    double ft;

    if( fi < 0 ){
        fi = -fi;
        t = fi;
        ft = fi - t;
        if( ft > 0.5 || (ft == 0.5 && (t & 0x01)) ){
            fi += 0.5;
        }
        fi = -fi;
    } else {
        t = fi;
        ft = fi - t;
        if( ft > 0.5 || (ft == 0.5 && (t & 0x01)) ){
            fi += 0.5;
        }
    }
    return (int)fi;
}

#ifdef __FPF_RND_USED_LONGLONG
static _FPF_RND_LONG_TYPE _doubleToInt64Even( double fi )
{
    unsigned _FPF_RND_LONG_TYPE t;
    double ft;

    if( fi < 0 ){
        fi = -fi;
        t = fi;
        ft = fi - t;
        if( ft > 0.5 || (ft == 0.5 && (t & 0x01))){
            fi += 0.5;
        }
        fi = -fi;
    } else {
        t = fi;
        ft = fi - t;
        if( ft > 0.5 || (ft == 0.5 && (t & 0x01))){
            fi += 0.5;
        }
    }
    return (_FPF_RND_LONG_TYPE)fi;
}
#endif

//
// double To fixed ؂グ (ceil)
//
static int _doubleToInt32Ceiling( double fi )
{
    int t;
    double ft;

    t = fi;
    ft = fi - t;
    if( ft > 0 ){
        t += 1;
    }
    return t;
}

#ifdef __FPF_RND_USED_LONGLONG
static _FPF_RND_LONG_TYPE _doubleToInt64Ceiling( double fi )
{
    _FPF_RND_LONG_TYPE t;
    double ft;

    t = fi;
    ft = fi - t;
    if( ft > 0 ){
        t += 1;
    }
    return t;
}
#endif

//
// double To fixed ؂̂ (Floor)
//
static int _doubleToInt32Floor( double fi )
{
    int t;
    double ft;

    t = fi;
    ft = fi - t;
    if( ft < 0 ){
        t += -1;
    }
    return t;
}

#ifdef __FPF_RND_USED_LONGLONG
static _FPF_RND_LONG_TYPE _doubleToInt64Floor( double fi )
{
    _FPF_RND_LONG_TYPE t;
    double ft;

    t = fi;
    ft = fi - t;
    if( ft < 0 ){
        t += -1;
    }
    return t;
}
#endif

#endif

//
// I[o[t[
//

//
// 32rbg rbg}XNe[u
//

#ifdef __FPF_MAX_16BIT
static unsigned int bit32Mask1[17] = {
    0x0000,
    0x0001, 0x0003, 0x0007, 0x000f,
    0x001f, 0x003f, 0x007f, 0x00ff,
    0x01ff, 0x03ff, 0x07ff, 0x0fff,
    0x1fff, 0x3fff, 0x7fff, 0xffff
};

static unsigned int bit32Mask2[18] = {
    0xffff, 0xffff,
    0xfffe, 0xfffc, 0xfff8, 0xfff0,
    0xffe0, 0xffc0, 0xff80, 0xff00,
    0xfe00, 0xfc00, 0xf800, 0xf000,
    0xe000, 0xc000, 0x8000, 0x0000
};

#else // ndef __FPF_MAX_16BIT

static unsigned int bit32Mask1[33] = {
    0x00000000,
    0x00000001, 0x00000003, 0x00000007, 0x0000000f,
    0x0000001f, 0x0000003f, 0x0000007f, 0x000000ff,
    0x000001ff, 0x000003ff, 0x000007ff, 0x00000fff,
    0x00001fff, 0x00003fff, 0x00007fff, 0x0000ffff,
    0x0001ffff, 0x0003ffff, 0x0007ffff, 0x000fffff,
    0x001fffff, 0x003fffff, 0x007fffff, 0x00ffffff,
    0x01ffffff, 0x03ffffff, 0x07ffffff, 0x0fffffff,
    0x1fffffff, 0x3fffffff, 0x7fffffff, 0xffffffff
};

static unsigned int bit32Mask2[34] = {
    0xffffffff, 0xffffffff,
    0xfffffffe, 0xfffffffc, 0xfffffff8, 0xfffffff0,
    0xffffffe0, 0xffffffc0, 0xffffff80, 0xffffff00,
    0xfffffe00, 0xfffffc00, 0xfffff800, 0xfffff000,
    0xffffe000, 0xffffc000, 0xffff8000, 0xffff0000,
    0xfffe0000, 0xfffc0000, 0xfff80000, 0xfff00000,
    0xffe00000, 0xffc00000, 0xff800000, 0xff000000,
    0xfe000000, 0xfc000000, 0xf8000000, 0xf0000000,
    0xe0000000, 0xc0000000, 0x80000000, 0x00000000
};

#endif


#ifdef _NO_INLINE_FPF_RND
static int _fixedInt32Wrp(int fi, int bitsize)
#else
static inline int _fixedInt32Wrp(int fi, int bitsize)
#endif
{
    int tmp;

    tmp = fi;
    fi &= bit32Mask1[bitsize];
    if( fi & bit32Mask2[bitsize] ){
        fi |= bit32Mask2[bitsize];
    }
//    ovf_flg = (fi != tmp);
    return fi;
}

// 32Bit Oa
#ifdef _NO_INLINE_FPF_RND
static int _fixedInt32Sat(int fi, int bitsize)
#else
static inline int _fixedInt32Sat(int fi, int bitsize)
#endif
{
    int tmp;
    int ovf_flg;

    tmp = fi;
    fi &= bit32Mask1[bitsize];
    if( fi & bit32Mask2[bitsize] ){
         fi |= bit32Mask2[bitsize];
    }

    ovf_flg = fi != tmp;
    if( ovf_flg != 0 ){
        if( tmp < 0 ){
            fi = bit32Mask2[bitsize];
        } else {
            fi = bit32Mask1[bitsize-1];
        }
    }
    return fi;
}

//  32rbg ؎̂
#ifdef _NO_INLINE_FPF_RND
static unsigned int _fixedUInt32Wrp(unsigned fi, int bitsize)
#else
static inline unsigned int _fixedUInt32Wrp(unsigned fi, int bitsize)
#endif
{
  unsigned int tmp;

  tmp = fi;
  fi &= bit32Mask1[bitsize];
//  ovf_flg = (fi != tmp);

  return fi;
}

//  32rbg Oa
#ifdef _NO_INLINE_FPF_RND
static unsigned int _fixedUInt32Sat(unsigned int fi, int bitsize)
#else
static inline unsigned int _fixedUInt32Sat(unsigned int fi, int bitsize)
#endif
{
    unsigned int tmp;
    int ovf_flg;

    tmp = fi;
    fi &= bit32Mask1[bitsize];
    ovf_flg = (fi != tmp);
    if( ovf_flg ){
        fi = bit32Mask1[bitsize];
    }
    return fi;
}


#ifdef __FPF_RND_USED_LONGLONG

//
// 64rbg rbg}XNe[u
//

#ifdef __FPF_MAX_16BIT

static unsigned long bit64Mask1[33] = {
    0x00000000L,
    0x00000001L, 0x00000003L, 0x00000007L, 0x0000000fL,
    0x0000001fL, 0x0000003fL, 0x0000007fL, 0x000000ffL,
    0x000001ffL, 0x000003ffL, 0x000007ffL, 0x00000fffL,
    0x00001fffL, 0x00003fffL, 0x00007fffL, 0x0000ffffL,
    0x0001ffffL, 0x0003ffffL, 0x0007ffffL, 0x000fffffL,
    0x001fffffL, 0x003fffffL, 0x007fffffL, 0x00ffffffL,
    0x01ffffffL, 0x03ffffffL, 0x07ffffffL, 0x0fffffffL,
    0x1fffffffL, 0x3fffffffL, 0x7fffffffL, 0xffffffffL
};

static unsigned long bit64Mask2[34] = {
    0xffffffffL, 0xffffffffL,
    0xfffffffeL, 0xfffffffcL, 0xfffffff8L, 0xfffffff0L,
    0xffffffe0L, 0xffffffc0L, 0xffffff80L, 0xffffff00L,
    0xfffffe00L, 0xfffffc00L, 0xfffff800L, 0xfffff000L,
    0xffffe000L, 0xffffc000L, 0xffff8000L, 0xffff0000L,
    0xfffe0000L, 0xfffc0000L, 0xfff80000L, 0xfff00000L,
    0xffe00000L, 0xffc00000L, 0xff800000L, 0xff000000L,
    0xfe000000L, 0xfc000000L, 0xf8000000L, 0xf0000000L,
    0xe0000000L, 0xc0000000L, 0x80000000L, 0x00000000L
};

#else

static long long int bit64Mask1[] = {
    0x0000000000000000ull, 0x0000000000000001ull, 0x0000000000000003ull,
    0x0000000000000007ull, 0x000000000000000full, 0x000000000000001full,
    0x000000000000003full, 0x000000000000007full, 0x00000000000000ffull,
    0x00000000000001ffull, 0x00000000000003ffull, 0x00000000000007ffull,
    0x0000000000000fffull, 0x0000000000001fffull, 0x0000000000003fffull,
    0x0000000000007fffull, 0x000000000000ffffull, 0x000000000001ffffull,
    0x000000000003ffffull, 0x000000000007ffffull, 0x00000000000fffffull,
    0x00000000001fffffull, 0x00000000003fffffull, 0x00000000007fffffull,
    0x0000000000ffffffull, 0x0000000001ffffffull, 0x0000000003ffffffull,
    0x0000000007ffffffull, 0x000000000fffffffull, 0x000000001fffffffull,
    0x000000003fffffffull, 0x000000007fffffffull, 0x00000000ffffffffull,
    0x00000001ffffffffull, 0x00000003ffffffffull, 0x00000007ffffffffull,
    0x0000000fffffffffull, 0x0000001fffffffffull, 0x0000003fffffffffull,
    0x0000007fffffffffull, 0x000000ffffffffffull, 0x000001ffffffffffull,
    0x000003ffffffffffull, 0x000007ffffffffffull, 0x00000fffffffffffull,
    0x00001fffffffffffull, 0x00003fffffffffffull, 0x00007fffffffffffull,
    0x0000ffffffffffffull, 0x0001ffffffffffffull, 0x0003ffffffffffffull,
    0x0007ffffffffffffull, 0x000fffffffffffffull, 0x001fffffffffffffull,
    0x003fffffffffffffull, 0x007fffffffffffffull, 0x00ffffffffffffffull,
    0x01ffffffffffffffull, 0x03ffffffffffffffull, 0x07ffffffffffffffull,
    0x0fffffffffffffffull, 0x1fffffffffffffffull, 0x3fffffffffffffffull,
    0x7fffffffffffffffull, 0xffffffffffffffffull,
};

static long long int bit64Mask2[] = {
    0xffffffffffffffffull, 0xffffffffffffffffull, 0xfffffffffffffffeull,
    0xfffffffffffffffcull, 0xfffffffffffffff8ull, 0xfffffffffffffff0ull,
    0xffffffffffffffe0ull, 0xffffffffffffffc0ull, 0xffffffffffffff80ull,
    0xffffffffffffff00ull, 0xfffffffffffffe00ull, 0xfffffffffffffc00ull,
    0xfffffffffffff800ull, 0xfffffffffffff000ull, 0xffffffffffffe000ull,
    0xffffffffffffc000ull, 0xffffffffffff8000ull, 0xffffffffffff0000ull,
    0xfffffffffffe0000ull, 0xfffffffffffc0000ull, 0xfffffffffff80000ull,
    0xfffffffffff00000ull, 0xffffffffffe00000ull, 0xffffffffffc00000ull,
    0xffffffffff800000ull, 0xffffffffff000000ull, 0xfffffffffe000000ull,
    0xfffffffffc000000ull, 0xfffffffff8000000ull, 0xfffffffff0000000ull,
    0xffffffffe0000000ull, 0xffffffffc0000000ull, 0xffffffff80000000ull,
    0xffffffff00000000ull, 0xfffffffe00000000ull, 0xfffffffc00000000ull,
    0xfffffff800000000ull, 0xfffffff000000000ull, 0xffffffe000000000ull,
    0xffffffc000000000ull, 0xffffff8000000000ull, 0xffffff0000000000ull,
    0xfffffe0000000000ull, 0xfffffc0000000000ull, 0xfffff80000000000ull,
    0xfffff00000000000ull, 0xffffe00000000000ull, 0xffffc00000000000ull,
    0xffff800000000000ull, 0xffff000000000000ull, 0xfffe000000000000ull,
    0xfffc000000000000ull, 0xfff8000000000000ull, 0xfff0000000000000ull,
    0xffe0000000000000ull, 0xffc0000000000000ull, 0xff80000000000000ull,
    0xff00000000000000ull, 0xfe00000000000000ull, 0xfc00000000000000ull,
    0xf800000000000000ull, 0xf000000000000000ull, 0xe000000000000000ull,
    0xc000000000000000ull, 0x8000000000000000ull, 0x0000000000000000ull,
};
#endif

// 64bit ؎̂āibvAEhj
#ifdef _NO_INLINE_FPF_RND
static _FPF_RND_LONG_TYPE _fixedInt64Wrp(long long int fi, int bitsize)
#else
static inline _FPF_RND_LONG_TYPE _fixedInt64Wrp(long long int fi, int bitsize)
#endif
{
    _FPF_RND_LONG_TYPE tmp;

    tmp = fi;
    fi &= bit64Mask1[bitsize];
    if( fi & bit64Mask2[bitsize] ){
        fi |= bit64Mask2[bitsize];
    }
//    ovf_flg = (fi != tmp);

    return fi;
}

// 64bit Oa
#ifdef _NO_INLINE_FPF_RND
static _FPF_RND_LONG_TYPE _fixedInt64Sat(long long int fi, int bitsize)
#else
static inline _FPF_RND_LONG_TYPE _fixedInt64Sat(long long int fi, int bitsize)
#endif
{
    _FPF_RND_LONG_TYPE int tmp;
    int ovf_flg;

    tmp = fi;
    fi &= bit64Mask1[bitsize];
    if( fi & bit64Mask2[bitsize] ){
         fi |= bit64Mask2[bitsize];
    }

    ovf_flg = (fi != tmp);
    if( ovf_flg != 0 ){
        if( tmp < 0 ){
            fi = bit64Mask2[bitsize];
        } else {
            fi = bit64Mask1[bitsize-1];
        }
    }
    return fi;
}

//  64rbg ؎̂
#ifdef _NO_INLINE_FPF_RND
static _FPF_RND_ULONG_TYPE _fixedUInt64Wrp(unsigned long long int fi, int bitsize)
#else
static inline _FPF_RND_ULONG_TYPE _fixedUInt64Wrp(unsigned long long int fi, int bitsize)
#endif
{
    _FPF_RND_ULONG_TYPE tmp;

    tmp = fi;
    fi &= bit64Mask1[bitsize];
//    ovf_flg = (fi != tmp);
    return fi;
}

//  64rbg Oa
#ifdef _NO_INLINE_FPF_RND
static _FPF_RND_ULONG_TYPE _fixedUInt64Sat(unsigned long long int fi, int bitsize)
#else
static inline unsigned long long int _fixedUInt64Sat(unsigned long long int fi, int bitsize)
#endif
{
    _FPF_RND_ULONG_TYPE tmp;
    int ovf_flg;

    tmp = fi;
    fi &= bit64Mask1[bitsize];
    ovf_flg = (fi != tmp);
    if( ovf_flg ){
         fi = bit64Mask1[bitsize];
    }
    return fi;
}

#endif // __FPF_RND_USED_LONGLONG


#if(0)

int main( int argc, char *argv[] )
{
    double src1[13] = {1.1, 1.2, 1.3, 1.4, 1.5, 1.6, 1.7, 1.8, 1.9, 2.0,
                        2.1, 2.5, 2.85 };
    double src2[13] = {-1.1, -1.2, -1.3,
                    -1.4, -1.5, -1.6, -1.7, -1.8, -1.9, -2.0,
                        -2.1, -2.5, -2.85 };
    double dTmp;
    int iTmp1, iTmp2;
    int i;

#if(0) //
    // ؎̂ eXg
printf( "====\n" ); //
    for( i = 0; i < 13; i++ ){
        dTmp = (src1[i] * (1<<2));
        iTmp1 = (int)dTmp;
        iTmp2 = _fixedIntMaskTrn( iTmp1, 2 );
        printf( "ans : %f, %f\n", src1[i], (double)iTmp2/(1<<2) );
    }

printf( "====\n" ); //
    for( i = 0; i < 13; i++ ){
        dTmp = (src2[i] * (1<<2));
        iTmp1 = (int)dTmp;
        iTmp2 = _fixedIntMaskTrn( iTmp1, 2 );
        printf( "ans : %f, %f\n", src2[i], (double)iTmp2/(1<<2) );
    }
#endif


#if(0) //
    // ÔPeXg
printf( "====\n" ); //
    for( i = 0; i < 13; i++ ){
        dTmp = (src1[i] * (1<<2));
        iTmp1 = (int)dTmp;
        iTmp2 = _fixedIntMaskRnd( iTmp1, 2 );
        printf( "ans : %f, %f\n", src1[i], (double)iTmp2/(1<<2) );
    }

printf( "====\n" ); //
    for( i = 0; i < 13; i++ ){
        dTmp = (src2[i] * (1<<2));
        iTmp1 = (int)dTmp;
        iTmp2 = _fixedIntMaskRnd( iTmp1, 2 );
        printf( "ans : %f, %f\n", src2[i], (double)iTmp2/(1<<2) );
    }
#endif

#if(0) //
    // ۂ߃eXg
printf( "====\n" ); //
    for( i = 0; i < 13; i++ ){
        dTmp = (src1[i] * (1<<2));
        iTmp1 = (int)dTmp;
        iTmp2 = _fixedIntMaskRndEven( iTmp1, 2 );
        printf( "ans : %f, %f\n", src1[i], (double)iTmp2/(1<<2) );
    }

printf( "====\n" ); //
    for( i = 0; i < 13; i++ ){
        dTmp = (src2[i] * (1<<2));
        iTmp1 = (int)dTmp;
        iTmp2 = _fixedIntMaskRndEven( iTmp1, 2 );
        printf( "ans : %f, %f\n", src2[i], (double)iTmp2/(1<<2) );
    }
#endif

#if(0) //
    // CeilingeXg
printf( "====\n" ); //
    for( i = 0; i < 13; i++ ){
        dTmp = (src1[i] * (1<<2));
        iTmp1 = (int)dTmp;
        iTmp2 = _fixedIntMaskCeiling( iTmp1, 2 );
        printf( "ans : %f, %f\n", src1[i], (double)iTmp2/(1<<2) );
    }

printf( "====\n" ); //
    for( i = 0; i < 13; i++ ){
        dTmp = (src2[i] * (1<<2));
        iTmp1 = (int)dTmp;
        iTmp2 = _fixedIntMaskCeiling( iTmp1, 2 );
        printf( "ans : %f, %f\n", src2[i], (double)iTmp2/(1<<2) );
    }
#endif

#if(0) //
    // EVtg؎̂ eXg
printf( "====\n" ); //
    for( i = 0; i < 13; i++ ){
        dTmp = (src1[i] * (1<<5));
        iTmp1 = (int)dTmp;
        iTmp2 = _fixedIntLsftTrn( iTmp1, 4 );
        printf( "ans : %f, %f\n", src1[i], (double)iTmp2/(1<<1) );
    }

printf( "====\n" ); //
    for( i = 0; i < 13; i++ ){
        dTmp = (src2[i] * (1<<5));
        iTmp1 = (int)dTmp;
        iTmp2 = _fixedIntLsftTrn( iTmp1, 4 );
        printf( "ans : %f, %f\n", src2[i], (double)iTmp2/(1<<1) );
    }
#endif

#if(0) //
    // EVtgÔP eXg
printf( "====\n" ); //
    for( i = 0; i < 13; i++ ){
        dTmp = (src1[i] * (1<<5));
        iTmp1 = (int)dTmp;
        iTmp2 = _fixedIntLsftRnd( iTmp1, 5 );
        printf( "ans : %f, %f\n", src1[i], (double)iTmp2/(1<<0) );
    }

printf( "====\n" ); //
    for( i = 0; i < 13; i++ ){
        dTmp = (src2[i] * (1<<5));
        iTmp1 = (int)dTmp;
        iTmp2 = _fixedIntLsftRnd( iTmp1, 5 );
        printf( "ans : %f, %f\n", src2[i], (double)iTmp2/(1<<0) );
    }
#endif

#if(0) //
    // EVtgۂ
printf( "====\n" ); //
    for( i = 0; i < 13; i++ ){
        dTmp = (src1[i] * (1<<5));
        iTmp1 = (int)dTmp;
        iTmp2 = _fixedIntLsftRndEven( iTmp1, 5 );
        printf( "ans : %f, %f\n", src1[i], (double)iTmp2/(1<<0) );
    }

printf( "====\n" ); //
    for( i = 0; i < 13; i++ ){
        dTmp = (src2[i] * (1<<5));
        iTmp1 = (int)dTmp;
        iTmp2 = _fixedIntLsftRndEven( iTmp1, 5 );
        printf( "ans : %f, %f\n", src2[i], (double)iTmp2/(1<<0) );
    }
#endif


#if(1) //
    // EVtgۂ
printf( "====\n" ); //
    for( i = 0; i < 13; i++ ){
        dTmp = (src1[i] * (1<<5));
        iTmp1 = (int)dTmp;
        iTmp2 = _fixedIntLsftCeiling( iTmp1, 5 );
        printf( "ans : %f, %f\n", src1[i], (double)iTmp2/(1<<0) );
    }

printf( "====\n" ); //
    for( i = 0; i < 13; i++ ){
        dTmp = (src2[i] * (1<<5));
        iTmp1 = (int)dTmp;
        iTmp2 = _fixedIntLsftCeiling( iTmp1, 5 );
        printf( "ans : %f, %f\n", src2[i], (double)iTmp2/(1<<0) );
    }
#endif



    return 0;
}
#endif

#endif

